Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 3836)
+++ trunk/SophyaLib/NTools/Makefile	(revision 3851)
@@ -673,78 +947,108 @@
  
 $(SOPHYAOBJP)tabmath.o: tabmath.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h tabmath.h peida.h \
-  $(SOPHYAINCP)utils.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)perrors.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)pexceptions.h fmath.h nbconst.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h tabmath.h peida.h \
+  $(SOPHYAINCP)utils.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)perrors.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h fmath.h nbconst.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tabmath.cc
  
-$(SOPHYAOBJP)toeplitzMatrix.o: toeplitzMatrix.cc \
-  $(SOPHYAINCP)sopnamsp.h toeplitzMatrix.h \
-  $(SOPHYAINCP)machdefs.h nbmath.h \
+$(SOPHYAOBJP)toeplitzMatrix.o: toeplitzMatrix.cc $(SOPHYAINCP)sopnamsp.h \
+  toeplitzMatrix.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h nbmath.h \
   $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)timing.h \
-  $(SOPHYAINCP)array.h \
-  $(SOPHYAINCP)tarray.h \
-  $(SOPHYAINCP)basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)utilarr.h \
-  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)timing.h \
+  $(SOPHYAINCP)array.h $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)basarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)utilarr.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tmatrix_tsnl.h \
-  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)tmatrix_tsnl.h \
+  $(SOPHYAINCP)tvector.h $(SOPHYAINCP)tmatrix.h \
   $(SOPHYAINCP)tvector_tsnl.h \
   $(SOPHYAINCP)matharr.h \
-  $(SOPHYAINCP)fioarr.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)tarray.h \
+  $(SOPHYAINCP)fioarr.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tarray.h $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)ppersist.h \
   $(SOPHYAINCP)sopemtx.h \
-  $(SOPHYAINCP)arrctcast.h fftservintf.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)tmatrix.h \
-  $(SOPHYAINCP)tvector.h fftpserver.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)tmatrix.h $(SOPHYAINCP)tvector.h \
+  $(SOPHYAINCP)arrctcast.h \
+  $(SOPHYAINCP)tarray.h $(SOPHYAINCP)spesqmtx.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)utilarr.h $(SOPHYAINCP)tmatrix.h \
+  $(SOPHYAINCP)diagmtx.h \
+  $(SOPHYAINCP)spesqmtx.h \
+  $(SOPHYAINCP)spesqmtx_tsnl.h \
+  $(SOPHYAINCP)trngmtx.h \
+  $(SOPHYAINCP)spesqmtx.h \
+  $(SOPHYAINCP)spesqmtx_tsnl.h \
+  $(SOPHYAINCP)symmtx.h $(SOPHYAINCP)spesqmtx.h \
+  $(SOPHYAINCP)spesqmtx_tsnl.h fftservintf.h fftpserver.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  toeplitzMatrix.cc
  
 $(SOPHYAOBJP)datime.o: datime.c $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
   $(SOPHYAINCP)strutil.h nbconst.h datime.h
 	$(CCOMPILE) -o $@  datime.c
  
 $(SOPHYAOBJP)fftmayer_r4.o: fftmayer_r4.c fftmayer.h \
-  $(SOPHYAINCP)machdefs.h trigtbl.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h trigtbl.h
 	$(CCOMPILE) -o $@  fftmayer_r4.c
  
 $(SOPHYAOBJP)fftmayer_r8.o: fftmayer_r8.c fftmayer.h \
-  $(SOPHYAINCP)machdefs.h trigtbl.h
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h trigtbl.h
 	$(CCOMPILE) -o $@  fftmayer_r8.c
  
-$(SOPHYAOBJP)fftpackc.o: fftpackc.c fftpackc.h \
-  $(SOPHYAINCP)machdefs.h
+$(SOPHYAOBJP)fftpackc.o: fftpackc.c fftpackc.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h
 	$(CCOMPILE) -o $@  fftpackc.c
  
-$(SOPHYAOBJP)matxop.o: matxop.c matxop.h nbmath.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)matxop.o: matxop.c matxop.h nbmath.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
   $(SOPHYAINCP)smathconst.h \
   $(SOPHYAINCP)machdefs.h
 	$(CCOMPILE) -o $@  matxop.c
  
-$(SOPHYAOBJP)nbmath.o: nbmath.c nbmath.h \
-  $(SOPHYAINCP)machdefs.h \
+$(SOPHYAOBJP)nbmath.o: nbmath.c nbmath.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
   $(SOPHYAINCP)smathconst.h \
-  $(SOPHYAINCP)machdefs.h matxop.h nbinteg.h \
-  nbtri.h
+  $(SOPHYAINCP)machdefs.h matxop.h nbinteg.h nbtri.h
 	$(CCOMPILE) -o $@  nbmath.c
  
-$(SOPHYAOBJP)nbtri.o: nbtri.c nbtri.h $(SOPHYAINCP)machdefs.h
+$(SOPHYAOBJP)nbtri.o: nbtri.c nbtri.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h
 	$(CCOMPILE) -o $@  nbtri.c
  
Index: trunk/SophyaLib/NTools/objlist.list
===================================================================
--- trunk/SophyaLib/NTools/objlist.list	(revision 3836)
+++ trunk/SophyaLib/NTools/objlist.list	(revision 3851)
@@ -1,2 +1,3 @@
+FSAppIrrSmpl.o
 cimage.o
 cspline.o
@@ -14,5 +15,4 @@
 fftpserver.o
 fftservintf.o
-FSAppIrrSmpl.o
 functab.o
 generaldata.o
@@ -32,4 +32,5 @@
 simplesort.o
 simplex.o
+slininterp.o
 slinparbuff.o
 tabmath.o
Index: trunk/SophyaLib/NTools/slininterp.cc
===================================================================
--- trunk/SophyaLib/NTools/slininterp.cc	(revision 3851)
+++ trunk/SophyaLib/NTools/slininterp.cc	(revision 3851)
@@ -0,0 +1,252 @@
+/*    
+   --- SOPHYA software - NTools module ---
+   --- Class SLinInterp1D : Simple linear 1D interpolation class
+   R. Ansari , C. Magneville   2000-2010 
+   (C) UPS+LAL IN2P3/CNRS     (C) IRFU-SPP/CEA 
+*/
+
+#include "slininterp.h"
+#include <fstream>
+
+namespace SOPHYA {
+
+/*! 
+  \class SLinInterp1D
+  \ingroup NTools
+  \brief Simple linear interpolation class 
+
+  \code
+  #include "slininterp.h"
+  #include "srandgen.h"
+
+  ...
+  vector<double> ys;
+  double xmin = 0.5;
+  double xmax = 0.;
+  for(int i=0; i<=12; i++) {
+    xmax = xmin+i*0.1;
+    yreg.push_back(sin(xmax)*cos(2.2*xmax));
+  }
+  SLinInterp1D interpYR(xmin, xmax, yreg);
+  cout << interpYR
+  for(int i=0; i<=12; i++) {
+    double x = drand01()*2.;
+    cout << " Interpol result for X=" << x << " -> " << interpYR(x) << " ?= " << sin(x)*cos(2.2*x) << endl;
+  }
+  \endcode 
+*/
+
+/* --Methode-- */
+SLinInterp1D::SLinInterp1D()
+  : xmin_(0.), xmax_(1.), dx_(1.), ksmx_(1), npoints_(0)
+{
+  xs_.push_back(0.);
+  xs_.push_back(1.); 
+  ys_.push_back(0.);
+  ys_.push_back(1.); 
+}
+
+/*
+  \brief Constructor from regularly spaced points in X with Y values defined by yreg 
+
+  \b xmin and \b xmax are the two extreme points in X corresponding to yreg.
+  Example: xmin=1, xmax=10, with yreg.size()=10 , 
+  yreg[0]=Y(1) , yreg[1]=Y(2)  ...  yreg[9]=Y(10) 
+*/
+SLinInterp1D::SLinInterp1D(double xmin, double xmax, vector<double>& yreg)
+  : xmin_(0.), xmax_(1.), dx_(1.), ksmx_(1), npoints_(0)
+{
+  DefinePoints(xmin, xmax, yreg);
+}
+
+
+/*!
+  \brief Constructor from a set of \b (xs[i],ys[i]) pairs.
+
+  if (npt > 0), interpolates to a finer regularly spaced grid, from \b xmin to \b xmax 
+  with npt points.  use \b (xs[0],xs[xs.size()-1]) as limits if \b xmax<xmin 
+*/
+SLinInterp1D::SLinInterp1D(vector<double>& xs, vector<double>& ys, double xmin, double xmax, size_t npt)
+  : xmin_(0.), xmax_(1.), dx_(1.), ksmx_(1), npoints_(0)
+{
+  DefinePoints(xs, ys, xmin, xmax, npt);
+}
+
+/* --Methode-- */
+double SLinInterp1D::YInterp(double x)  const
+{
+  if (npoints_>0) {  // on utilise les points regulierement espace 
+    long i = (long)((x-xmin_)/dx_);  
+    if (i<0) return ( yreg_[0]+(x-xmin_)*(yreg_[1]-yreg_[0])/dx_ );
+    if (i>=npoints_) return ( yreg_[npoints_]+(x-xmax_)*(yreg_[npoints_]-yreg_[npoints_-1])/dx_ );
+    return (yreg_[i]+(x-X(i))/dx_*(yreg_[i+1]-yreg_[i]));
+  }
+  else {  // On utilise les points xs_,ys_ directement 
+    if (x<=xs_[0]) return ( ys_[0]+(x-xs_[0])*(ys_[1]-ys_[0])/(xs_[1]-xs_[0]) );
+    if (x>=xs_[ksmx_]) return ( ys_[ksmx_]+(x-xs_[ksmx_])*(ys_[ksmx_]-ys_[ksmx_-1])/(xs_[ksmx_]-xs_[ksmx_-1]) );
+
+    size_t k=1;
+    while(x>xs_[k]) k++; 
+    if (k>=xs_.size()) {  // ne devrait pas arriver ...
+      string emsg = " SLinInterp1D::YInterp()  out of range k -> BUG in code ";
+      throw out_of_range(emsg);
+    }
+
+    double rv=ys_[k-1]+(x-xs_[k-1])*(ys_[k]-ys_[k-1])/(xs_[k]-xs_[k-1]);
+    //    cout << " DBG- x=" << x << " k=" << k << " xs[k]=" << xs_[k] << " ys[k]" << ys_[k] 
+    //	 << " rv=" << rv << endl;
+    return rv;
+  }
+}
+
+/*
+  \brief Defines the interpolation points from regularly spaced points in X with Y values defined by yreg 
+
+  \b xmin and \b xmax are the two extreme points in X corresponding to yreg.
+  Example: xmin=1, xmax=10, with yreg.size()=10 , 
+  yreg[0]=Y(1) , yreg[1]=Y(2)  ...  yreg[9]=Y(10) 
+*/
+void SLinInterp1D::DefinePoints(double xmin, double xmax, vector<double>& yreg)
+{
+  if (yreg.size()<2)  {
+    string emsg = "SLinInterp1D::DefinePoints(xmin,xmax,yreg) Bad parameters yreg.size()<2 ";
+    throw range_error(emsg);
+  }
+  xmin_ = xmin; 
+  xmax_ = xmax;
+  npoints_ = yreg.size()-1;
+  dx_ = (xmax_-xmin_)/(double)npoints_;
+  yreg_ = yreg;
+}
+
+
+/*!
+  \brief Define the interpolation points from a set of \b (xs[i],ys[i]) pairs.
+
+  if (npt > 0), interpolates to a finer regularly spaced grid, from \b xmin to \b xmax 
+  with npt points.  use \b (xs[0],xs[xs.size()-1]) as limits if \b xmax<xmin 
+*/
+void SLinInterp1D::DefinePoints(vector<double>& xs, vector<double>& ys, double xmin, double xmax, size_t npt)
+{
+  if ((xs.size() != ys.size())||(xs.size()<2))  {
+    string emsg = "SLinInterp1D::DefinePoints() Bad parameters (xs.size() != ys.size())||(xs.size()<2) ";
+    throw range_error(emsg);
+  }
+  for(size_t k=1; k<xs.size(); k++) {
+    if (xs[k-1]>=xs[k])  { 
+       string emsg =  "SLinInterp1D::DefinePoints()  unsorted xs ";
+      throw range_error(emsg);
+    }
+  }
+  xs_=xs;
+  ys_=ys;
+  ksmx_=xs_.size()-1;
+  npoints_ = npt;
+  if (xmin>=xmax)  {
+    xmin_ = xs_[0]; 
+    xmax_ = xs_[ksmx_];
+  }
+  else {
+    xmin_ = xmin; 
+    xmax_ = xmax;
+  }
+  if (npoints_<1) {
+    dx_=(xmax_-xmin_)/(double)(xs_.size()-1);
+    return;
+  }
+  dx_ = (xmax_-xmin_)/(double)npoints_;
+  yreg_.resize(npoints_+1);
+  
+  // Compute the the y values for regularly spaced x xmin <= x <= xmax 
+  // and keep values in the yreg vector
+  yreg_[0] = ys_[0];
+  yreg_[npoints_] = ys_[ksmx_];
+  size_t k=1;
+  for(size_t i=0; i<npoints_; i++)  {
+    double x = X(i);
+    while(x>xs_[k]) k++;
+    if (k>=xs_.size())  k=xs_.size()-1;   
+    yreg_[i] = ys_[k-1]+(x-xs_[k-1])*(ys_[k]-ys_[k-1])/(xs_[k]-xs_[k-1]);
+    //DBG cout << " DBG* i=" << i << " X(i)=" << X(i) << " yreg_[i]= " << yreg_[i] << " X^2= " << X(i)*X(i) 
+    //DBG << " k=" << k << " xs[k]=" << xs_[k] << endl;
+  }
+  return;
+}
+
+
+/* --Methode-- */
+size_t SLinInterp1D::ReadYFromFile(string const& filename, double xmin, double xmax)
+{
+  ifstream inputFile;
+  inputFile.open(filename.c_str(), ifstream::in);  
+  if(! inputFile.is_open()) {
+    string emsg = "  SLinInterp1D::ReadYFromFile() problem opening file ";
+    emsg += filename;
+    throw runtime_error(emsg);
+  }
+  vector<double> xsv, ysv;
+
+  size_t cnt=0;
+  double cola;
+  while(!inputFile.eof())  { 
+    inputFile.clear(); 
+    inputFile >> cola; 
+    if ( (!inputFile.good()) || inputFile.eof())   break;
+    //cout << cola<< "    "<<colb<<endl;
+    ysv.push_back(cola);
+    cnt++;
+  }
+  inputFile.close();
+  cout << " SLinInterp1D::ReadYFromFile()/Info: " << cnt << " Y-values read from file " << filename << endl;  
+  DefinePoints(xmin, xmax, ysv);
+  return cnt;
+}
+
+/* --Methode-- */
+size_t SLinInterp1D::ReadXYFromFile(string const& filename, double xmin, double xmax, size_t npt)
+{
+  ifstream inputFile;
+  inputFile.open(filename.c_str(), ifstream::in);  
+  if(! inputFile.is_open()) {
+    string emsg = "  SLinInterp1D::ReadXYFromFile() problem opening file ";
+    emsg += filename;
+    throw runtime_error(emsg);
+  }
+  vector<double> xsv, ysv;
+
+  size_t cnt=0;
+  double cola, colb;
+  while(!inputFile.eof())  {  
+    inputFile.clear();
+    inputFile >> cola >> colb; 
+    if ( (!inputFile.good()) || inputFile.eof())   break;
+    // cout << " DEBUG - cnt=" << cnt << " x=" << cola << "  y= "<<colb<<endl;
+    xsv.push_back(cola);
+    ysv.push_back(colb);
+    cnt++;
+  }
+  inputFile.close();
+  cout << " SLinInterp1D::ReadXYFromFile()/Info: " << cnt << " (x,y) pairs read from file " << filename << endl;  
+  DefinePoints(xsv, ysv, xmin, xmax, npt);
+  return cnt;
+}
+
+
+/* --Methode-- */
+ostream& SLinInterp1D::Print(ostream& os, int lev)  const
+{
+  os << " ---- SLinInterp1D::Print() XMin=" << XMin() << " XMax=" << XMax() << " NPoints=" << npoints_ << endl;
+  os << "  xs_.size()= " << xs_.size() << "  ys_.size()= " << ys_.size() << "  yreg_.size()= " << yreg_.size() << endl;
+  if ((lev>0)&&(xs_.size()>0)) {
+    for(size_t i=0; i<xs_.size(); i++) 
+      os << " xs[" << i << " ]=" << xs_[i] << " -> ys[" << i << "]=" << ys_[i] << endl;
+  } 
+  if ((lev>0)&&(yreg_.size()>0)) {
+    for(size_t i=0; i<yreg_.size(); i++) 
+      os << " Regularly Spaced X(" << i << " )=" << X(i) << " -> yreg_[" << i << "]=" << yreg_[i] << endl;
+  } 
+  os << " -----------------------------------------------------------------------" << endl;
+}
+
+}  // End namespace SOPHYA 
+
Index: trunk/SophyaLib/NTools/slininterp.h
===================================================================
--- trunk/SophyaLib/NTools/slininterp.h	(revision 3851)
+++ trunk/SophyaLib/NTools/slininterp.h	(revision 3851)
@@ -0,0 +1,83 @@
+#ifndef SLININTERP_H_SEEN
+#define SLININTERP_H_SEEN
+/*    
+   --- SOPHYA software - NTools module ---
+   --- Class SLinInterp1D : Simple linear 1D interpolation class
+   R. Ansari , C. Magneville   2000-2010 
+   (C) UPS+LAL IN2P3/CNRS     (C) IRFU-SPP/CEA 
+*/
+
+#include "machdefs.h"
+#include <iostream>
+#include <vector>
+#include <string>
+#include <exception>
+#include <stdexcept>
+
+#include "genericfunc.h"
+
+using namespace std;
+
+//-------------------------------------------
+// --- Class SLinInterp1D : 
+//  Simple linear 1D interpolation class 
+//-------------------------------------------
+
+namespace SOPHYA {
+
+class SLinInterp1D : public GenericFunc {
+public :
+  //! Default constructor - represent the function y=x
+  SLinInterp1D(); 
+  // Regularly spaced points in X with Y values defined by yreg 	
+  SLinInterp1D(double xmin, double xmax, vector<double>& yreg);
+  //  Interpolate to a finer regularly spaced grid, from xmin to xmax with npt points if (npt>0)
+  SLinInterp1D(vector<double>& xs, vector<double>& ys, double xmin=1., double xmax=-1., size_t npt=0); 
+
+  virtual ~SLinInterp1D() { }
+        
+  double XMin() const { return xmin_; }
+  double XMax() const { return xmax_; }
+  double DeltaX()  { return dx_; }
+  inline double X(long i) const {return xmin_ + i*dx_;}  // returns x value for index i
+
+  // --------------------------------------------------------------
+  //! Return the interpolated Y value as a function of X 
+  double YInterp(double x) const ;
+  // To compile without SOPHYA : Comment the following line 
+  //! Return the interpolated Y value as a function of X 
+  virtual inline double operator()(double x) {  return YInterp(x); }
+  // --------------------------------------------------------------
+        
+  // Define the interpolation points through a set of regularly spaced points on X, between xmin and xmax 
+  void DefinePoints(double xmin, double xmax, vector<double>& yreg);
+  // Interpolate to a finer regularly spaced grid, from xmin to xmax with npt points 
+  void DefinePoints(vector<double>& xs, vector<double>& ys, double xmin=1., double xmax=-1., size_t npt=0); 
+
+  //! Read  Y's  ( one  / line) for regularly spaced X's from file and call DefinePoints(xmin, xmax, yreg)
+  size_t ReadYFromFile(string const& filename, double xmin, double xmax);
+  //! Read pairs of X Y ( one pair / line) from file and call DefinePoints(xs, ys ...)
+  size_t ReadXYFromFile(string const& filename, double xmin=1., double xmax=-1., size_t npt=0);
+  
+  vector<double>& GetVX()  { return xs_; }
+  vector<double>& GetVY()  { return ys_; }
+
+  //! Print the object (interpolation points) on "ostream". lev=0,1
+  ostream& Print(ostream& os,int lev=0) const ;
+  //! Print the object (interpolation points) on "cout". lev=0,1
+  inline ostream& Print(int lev=0) const { return Print(cout, lev); } 
+
+protected:
+  vector<double> yreg_, xs_, ys_;  // interpolated y value for regularly spaced x 
+  double xmin_, xmax_, dx_;        // dx is spacing of finer grid of x's
+  size_t ksmx_;                    // Maximum index value in xs_, ys_
+  size_t npoints_;                 // Number of regularly spaced points, xmax not included 
+};
+
+/*! operator << overloading - Prints the interpolator object on the stream \b s */
+inline ostream& operator << (ostream& s, SLinInterp1D const& a) 
+{ a.Print(s,0);  return s; }
+
+} // namespace SOPHYA
+
+#endif   /* SLININTERP_H__SEEN */
